
#ifndef FIELDUNITS_H
#define FIELDUNITS_H 1

// Temporary solution, until there is SystemOfUnits.h

namespace fieldUnits
{
   constexpr double gigaElectronVolt = 1.0; // native unit of energy
   constexpr double centimeter       = 1.0; // native unit of length
   constexpr double second           = 1.0; //

   constexpr double eplus   = 1.0 ;         // TBC

   constexpr double e_SI  = 1.602176487e-19;// positron charge in coulomb

   static constexpr double megaElectronVolt = 0.001 * gigaElectronVolt;
   static constexpr double electronVolt = 1.0e-9 * gigaElectronVolt;

   static constexpr double GeV        = gigaElectronVolt;
   static constexpr double MeV        = megaElectronVolt;

   static constexpr double nanosecond   = 1.e-9 *second;

   static constexpr double meter      = 100.0 * centimeter; 
   static constexpr double millimeter = 0.1 * centimeter;

   static constexpr double meter2     = meter * meter; 

   static constexpr double volt       = electronVolt/eplus;
   static constexpr double tesla      = volt*second/meter2; // tesla =0.001*megavolt*ns/mm2

   static constexpr double kilogauss  = 0.1    * tesla;
   static constexpr double gauss      = 1.0e-4 * tesla;

  // Angle
   static const double radian      = 1.;                  
   static const double milliradian = 1.e-3*radian;

   static constexpr double     pi_u = 3.1415926535897932384626;
   static const double degree = (pi_u/180.0)*radian;
   
   // To be moved into Constants.h etc
}
#endif
