//===--- physical_constants.h - Geant-V -------------------------*- C++ -*-===//
//
//                     Geant-V Prototype               
//
//===----------------------------------------------------------------------===//
/**
 * @file physical_constants.h
 * @brief Definition of physical constants used in Geant-V prototype 
 * @author Andrei Gheata 
 */
//===----------------------------------------------------------------------===//

static const double PI = 3.14159265358979323846;

// Units
static const double MeV = 1.0;
static const double keV = 0.001 * MeV;
static const double eV = 0.001 * keV;

// Physical constants
static const double electron_mass_c2 = 0.510998910 * MeV;
